(*	XYZ GeoBench (eXperimental geometrY Zurich):		*)
(*	An object oriented, interactive workbench for		*)
(*	experimental geometric computation.					*)
(*														*)
(*	 1999 by Peter Schorn, peter.schorn@acm.org		*)
(*	Culmannstrasse 77, CH-8006 Zrich, Switzerland		*)
(*	This software may be copied freely for educational	*)
(*	and research purposes only. For commercial use,		*)
(*	please contact the author.							*)
(*														*)
(*	Version 5.0.5: 30-Sep-1999							*)

unit geoBenchGlobal;

interface

uses
{$IFC Topography }
	QDPicture,
{$ENDC }
{$IFC ScriptEnabled }
	GeoScript,
{$ENDC }
pointVector, splinegon, avlTree;

const
	maxVertices = 10000; (* maximum number vertices allowed in 'regularNGon' *)
	closeAlertResource = 303;
	garbageTime = 100;
	yesItem = 1;
	okItem = 1;
	noItem = 2;
	cancelItem = 3;
	noInfoAlertResource = 1009;
	memoryFullAlertResource = 1010;
	suppressItem = 3;
	maxWindow = 16;
	maxframe = 10;
	standardXOffset = 0;
	standardYOffset = 40;
	standardDx = 18;
	standardDy = 18;
	infoWindowWidth = 394;
	infoWindowHeight = 188;
	escChar = chr(27);

	appleMenuString = 'About GeoBench...;Operation Info...';
	aboutItem = 1;
	commandInfoItem = 2;
	fileMenuID = 2;
	newItem = 1;
	openItem = newItem + 1;
	closeItem = openItem + 1;
	saveItem = closeItem + 2;
	saveAsItem = saveItem + 1;
	saveACopyAsItem = saveAsItem + 1;
	revertItem = saveACopyAsItem + 1;
	writeTextItem = revertItem + 2;
	readTextItem = writeTextItem + 1;
	preferencesItem = readTextItem + 2;
{$IFC netWorkEnabled }
	networkItem = preferencesItem + 2;				(* MS: 5.8.93 *)
{$IFC Topography }
	topographyItem = networkItem + 1;
	quitItem = topographyItem + 2;
	fileMenuString = 'New/N;Open.../O;Close/W;(-;Save/S;Save As...;Save a Copy As...;Revert;(-;Write Text...;Read Text...;(-;Preferences;(-;Network/!;Topography/!;(-;Quit/Q';
{$ELSEC }
	quitItem = networkItem + 2;
	fileMenuString = 'New/N;Open.../O;Close/W;(-;Save/S;Save As...;Save a Copy As...;Revert;(-;Write Text...;Read Text...;(-;Preferences;(-;Network/!;(-;Quit/Q';
{$ENDC }
{$ELSEC }
{$IFC Topography }
	topographyItem = preferencesItem + 2;
	quitItem = topographyItem + 2;
	fileMenuString = 'New/N;Open.../O;Close/W;(-;Save/S;Save As...;Save a Copy As...;Revert;(-;Write Text...;Read Text...;(-;Preferences;(-;Topography/!;(-;Quit/Q';
{$ELSEC }
	quitItem = preferencesItem + 2;
	fileMenuString = 'New/N;Open.../O;Close/W;(-;Save/S;Save As...;Save a Copy As...;Revert;(-;Write Text...;Read Text...;(-;Preferences;(-;Quit/Q';
{$ENDC }
{$ENDC }

	editMenuID = 3;
	editMenuString = 'Undo/Z;(-;Cut/X;Copy/C;Paste/V;(-;Cut First;Copy First;Select Next/L;Duplicate/D;(-;Clear All;Select All/A;Redraw;(-;Zoom In.../E;Zoom Out/F;(-;Transformations/!;(-;3d Projection...;3d Transformations...;(-;Clear Scrapbook';
	undoItem = 1;
	cutItem = 3;
	copyItem = 4;
	pasteItem = 5;
	cutFirstItem = 7;
	copyFirstItem = 8;
	selectNextItem = 9;
	duplicateItem = 10;
	clearItem = 12;
	selectAllItem = 13;
	redrawItem = 14;
	zoomInItem = 16;
	zoomOutItem = 17;
	transformItem = 19;
	eyePointItem = 21;
	setUserTItem = 22;
	clearClipboardItem = 24;

	transMenuID = 9;
	transMenuString = 'Translate...;Rotate...;Scale...;Reflect...';
	translateItem = 1;
	rotateItem = 2;
	scaleItem = 3;
	reflectItem = 4;

{$IFC NetworkEnabled }
	cosimaMenuID = 10;
	cosimaMenuString = 'Open as Client;Open as Server';			(* MS: 19.7 .93 - Cosima Network sub-menu *)
	openAsClientItem = 1;
	openAsServerItem = 2;
{$ENDC }

{$IFC Topography }
	topoMenuID = 11;
	topoMenuString = 'Read As Polygons...;B&W Map...;Gray Scale Map...;Color Map...;Read As Triangulation...';
	readPolygonsItem = 1;
	bwMapItem = 2;
	grayScaleMapItem = 3;
	colorMapItem = 4;
	readTriangItem = 5;
{$ENDC }

	objectsMenuID = 4;
{$IFC ScriptEnabled }
	objectsMenuString = 'Select;(-;Point;Line Segment;Polyline;Polygon;Convex Polygon;Rectangle;Circle;N-Gon...;D-Point...;(-;Object Info.../I;(-;Group/G;Ungroup/H;(-;Execute/=;(-;Random Create.../R;Random Change/M;Random Generator/!';
{$ELSEC }
	objectsMenuString = 'Select;(-;Point;Line Segment;Polyline;Polygon;Convex Polygon;Rectangle;Circle;N-Gon...;D-Point...;(-;Object Info.../I;(-;Group/G;Ungroup/H;(-;Random Create.../R;Random Change/M;Random Generator/!';
{$ENDC }
	selectItem = 1;
	pointItem = selectItem + 2;
	lineSegmentItem = pointItem + 1;
	polyLineItem = lineSegmentItem + 1;
	polygonItem = polyLineItem + 1;
	convexPolygonItem = polygonItem + 1;
	rectangleItem = convexPolygonItem + 1;
	circleItem = rectangleItem + 1;
	regularNGonItem = circleItem + 1;
	dDimPointItem = regularNGonItem + 1;
	firstObjectItem = pointItem;
	lastObjectItem = dDimPointItem;
	lastSimpleObjectItem = circleItem;
	objInfoItem = lastObjectItem + 2;
	groupItem = objInfoItem + 2;
	ungroupItem = groupItem + 1;
{$IFC ScriptEnabled }
	executeItem = ungroupItem + 2;
	randomItem = executeItem + 2;
{$ELSEC }
	randomItem = ungroupItem + 2;
{$ENDC }
	randomChangeItem = randomItem + 1;
	randomGeneratorItem = randomChangeItem + 1;

	randomGeneratorMenuID = 12;
	randomGeneratorMenuString = 'Randomize Seed;Reset Seed;Set Seed...';
	randomizeSeedItem = 1;
	resetSeedItem = 2;
	setSeedItem = 3;


	operationsMenuID = 5;

	windowsMenuID = 6;
{$IFC ScriptEnabled }
	windowsMenuString = 'Hide;Show All;(-;Info;Animation;(-;GeoScript/B;(-';
{$ELSEC }
	windowsMenuString = 'Hide;Show All;(-;Info;Animation;(-';
{$ENDC }
	hideItem = 1;
	ShowAllItem = hideItem + 1;
	infoItem = ShowAllItem + 2;
	AnimationWindowItem = infoItem + 1;
{$IFC ScriptEnabled }
	geoScriptItem = AnimationWindowItem + 2;
	lastWindowItem = geoScriptItem;
{$ELSEC }
	lastWindowItem = AnimationWindowItem;
{$ENDC }

	animationMenuID = 7;

	arithmeticMenuID = 8;
	arithmeticMenuString = 'Real;(-;Float;Base...;Precision...;(-;Longint;(-;Lp Metric...';
	realItem = 1;
	floatItem = 3;
	baseItem = 4;
	precisionItem = 5;
	longIntItem = 7;
	lpMetricItem = 9;

	firstSubMenuID = 13;
	maxSubMenuID = 50;

	minWindowHeight = (ord(lastObjectItem) - ord(firstObjectItem) + 2) * paletteWidth - 1;
	minWindowWidth = 100;
	standardHeight = 205; (* must be greater than 'minWindowHeight' *)
	standardWidth = standardHeight + paletteWidth;
	scrollMargin = 10;
	sheetMargin = 10;
	maxScrollValue = 10000;
	scrollStepRatio = 0.05; (* part of page scrolled when pressing arrow button *)
	safetyMargin = 5; (* cf. RandomCreate *)
	initialDefaultNumber = 10;
	DeleteKey = chr(8);
	geoPrefix = 'Geo - ';
	palettePict = 101;

type
	frameIndex = 1..maxframe;
	frameStack = record
			stackPointer: frameIndex;
			stack: array[frameIndex] of wFrame;
		end;
	windowIndex = 1..maxWindow;
	windowIndex0 = 0..maxWindow;
	objectItems = firstObjectItem..lastObjectItem;
	windowStatus = record
			desktop, selection, names, types: list;
		(* WARNING: whenever the current window's desktop or selection is changed, *)
		(* the procedure forgetUndo (unit geoBenchGlobal, see comment there) must be called ! *)
			sheet: Rect; (* drawing sheet of this window *)
			modified, systemName, sheetExtended: boolean; (* was a name chosen by system or by user? *)
			fileName, name: Str255;
			volume: integer;
			window: WindowPtr;
			frames: frameStack;
			verScroll, horScroll: ControlHandle;
			verScrollFactor, horScrollFactor: real;
			zoomed: boolean;
			zoomRect: Rect;
			zoomOffset: Point;
{$IFC ScriptEnabled }
			script: geoScript;
{$ENDC }
		end;
	undoCommand = (dragDesktopCmd, dragSelectionCmd, clearCmd, clearAllCmd, transformCmd, setInfoCmd, randomChangeCmd, replaceSelectionCmd, ungroupCmd); (* 8 types of undoable commands *)
		(* update the procedures 'enableEditMenu' (unit geoBenchGlobal) and *)
		(* 'executeUndo' (unit geoBenchEditMenu) after changing the type 'undoCommand' ! *)
	resultHandlingModeType = (createNewWindowMode, createNewAdjacentWindowMode, addResultMode, replaceSelectionMode, throwAwayResultMode);
	windowStatusArray = array[windowIndex] of windowStatus;
	windowStatusArrayP = ^windowStatusArray;

const
	firstResultHandlingMode = createNewWindowMode;
	lastResultHandlingMode = throwAwayResultMode;

var
{$IFC NetworkEnabled }
	cosimaMenu: MenuHandle; 			(* MS: 19.7.93 - Cosima Menu Handle *)
{$ENDC }
{$IFC Topography }
	topoMenu: MenuHandle;
{$ENDC }
	fileMenu, editMenu, transMenu, objectsMenu, operationsMenu, windowsMenu, arithmeticMenu, randomGeneratorMenu: MenuHandle;
	windowCount, lastActiveWindow, offScreenId: windowIndex0;
	selectedType: objectType; (* lastObjectType = no type selected  *)
	selectedItem, waitLimit, geoBenchFont, lastSubMenuID: integer;
	wStatus: windowStatusArrayP;
	itemToType: array[objectItems] of objectType;
	typeToItem: array[objectType] of objectItems;
	scrapBook: list; (* scrapbook = nil means external scrap is taken *)
	undoScrap: list; (* undoScrap = nil means undo disabled; see procedure forgetUndo *)
	undoCmd: undoCommand; (* type of latest undoable command *)
	undoPosition: elementH;
	undoWindow: windowIndex0; (* window in which undoable command was performed *)
	cpuTimeUsedLower, cpuTimeUsedUpper, realTimeUsed: real;
	garbageTimer, lastMemoryAlertPrinted, previousClickTime, maxDrawingComplexity, maxScrapBookComplexity, maxStopWatchComplexity: longInt;
	defaultDimension, defaultVertices, defaultPolyVertices, defaultPolyObjects, defaultNumber, defaultAngle, defaultDx, defaultDy, defaultOriginX, defaultOriginY, defaultLambda, defaultA, defaultB, defaultC, defaultRegularNGonAngle: extended;
	exclusionSet: objectTypeSet;
	paletteSelect: Rect;
	paletteObjects: array[objectItems] of Rect;
	sPDialogPos, uTDialogPos, previousClickPoint: Point;
	defaultAlignmentIsOn, resultHandlingModifiersAllowed, shiftKeyPressed, optionKeyPressed, memoryAlertEnabled, processInBackground, notificationPending, geoBenchIsComputing: boolean;
	resultHandlingMode: resultHandlingModeType;
	previousFrontWindow: WindowPtr;
	currentOperation: Str255;


function currentWindow: windowIndex0;

function actualWindow: windowIndex;

{$IFC ScriptEnabled }
function currentScriptWindow: integer;
{$ENDC }

procedure forgetUndo;
(* Forget the latest undoable command. The undo command assumes that the top window's *)
(* selection and desktop are in exactly the same state as they were immediately after the *)
(* undoable command, therefore call this procedure whenever either the top window or its desktop *)
(* or selection is changed *)

function numberToString (x: integer): Str255;

function windowName (windowId: windowIndex): Str255;

procedure enableItems (isBefore: boolean);

procedure testObject (arguments: list; var nameList, typeList: list);

procedure initPalette;

procedure ExtendSheet (x, y: integer);

procedure updateScrollBars (w: windowIndex);

procedure redraw (w: windowIndex);

procedure writeTiming;

procedure initTiming (var realStartTime: longInt);

procedure finishTiming (realStartTime: longInt);

procedure DoMClobber (m: MenuHandle);

procedure drawGrow (w: WindowPtr);

procedure littleClip (w: WindowPtr);

procedure bigClip (w: WindowPtr);

function drawingRectangle (w: WindowPtr): rectangle;

function goodVersion: boolean;

procedure stopwatchFreeAll (var o: obj);		(*	Frees 'o' and displays the stopwatch if 'o' if big.		*)

function stopwatchDuplicateAll (o: obj): obj;		(*	Duplicates 'o' and displays the stopwatch if 'o' is big.	*)

function getScrapSize: longInt;

procedure DoCursorUpdate;

procedure idleTask;

procedure updatePalette (item: integer);

procedure deactivatePalette;

procedure DoArithmeticMenu (menu, item: integer; when: longInt);

function typeToString (t: objectType): Str255;

procedure enableDisableOperationsMenu (drawBar: boolean);

function getPortRect (window: WindowPtr): Rect;

implementation

{$IFC NOT THINK_PASCAL }
uses Fonts, Scrap, NumberFormatting;
{$ENDC }

function getPortRect (window: WindowPtr): Rect;
	var
		r: Rect;
		safe: GrafPtr;
	begin
		GetPort(safe);
		SetPort(window);
		r := window^.portRect;
		LocalToGlobal(r.topLeft);
		LocalToGlobal(r.botRight);
		SetPort(safe);
		getPortRect := r;
	end;

procedure enableDisableOperationsMenu (drawBar: boolean);
	begin
		if operationsMenu <> nil then begin
			if (windowCount = maxWindow) & ((resultHandlingMode = createNewWindowMode) | (resultHandlingMode = createNewAdjacentWindowMode)) then
				DisableItem(operationsMenu, 0)
			else
				EnableItem(operationsMenu, 0);
			if drawBar then
				DrawMenuBar;
		end;
	end;

function drawingRectangle (w: WindowPtr): rectangle;
	var
		r: rectangle;
		re: Rect;
	begin
		new(r);
		failNil(Handle(r));
		r.init;
		re := drawingRect(w);
		r.top := re.bottom - safetyMargin;
		r.bottom := re.top + safetyMargin;
		r.left := re.left + safetyMargin;
		r.right := re.right - safetyMargin;
		r.windowToWorld;
		drawingRectangle := r;
	end;

procedure littleClip (w: WindowPtr);
	begin
		ClipRect(drawingRect(w));
	end;

procedure bigClip (w: WindowPtr);
	begin
		ClipRect(w^.portRect);
	end;

procedure drawGrow (w: WindowPtr);
	var
		safe: integer;
		r: Rect;
	begin
		r := w^.portRect;
		r.left := r.left + paletteWidth;
		ClipRect(r);
		safe := w^.pnMode;
		PenMode(patOr);
		DrawGrowIcon(w);
		PenMode(safe);
		littleClip(w);
	end;

procedure initPalette;
	var
		w: WindowPtr;
		top, i: integer;
		pnState: PenState;
		paletteRect, emptyRect: Rect;
	begin
		w := wStatus^[actualWindow].window;
		bigClip(w);
		top := paletteWidth;
		SetRect(paletteSelect, -paletteWidth, 0, -1, top - 1);
		for i := firstObjectItem to lastObjectItem do begin
			SetRect(paletteObjects[i], -paletteWidth, top, -1, top + paletteWidth - 1);
			top := top + paletteWidth
		end;
		SetRect(paletteRect, -paletteWidth - 1, -1, 0, top);
		SetRect(emptyRect, -paletteWidth - 1, top, 0, w^.portRect.bottom);
		DrawPicture(GetPicture(palettePict), paletteRect);
		EraseRect(emptyRect);
		if w = FrontWindow then
			if selectedItem = selectItem then
				InvertRect(paletteSelect)
			else
				InvertRect(paletteObjects[selectedItem]);
		GetPenState(pnState);
		PenNormal;
		MoveTo(-1, 0);
		Line(0, w^.portRect.bottom);
		SetPenState(pnState);
		littleClip(w);
	end;

function currentWindow: windowIndex0;
	var
		fw: WindowPtr;
		w: longInt;
	begin
		fw := FrontWindow;
		if fw = nil then
			currentWindow := 0
		else begin
			w := GetWRefCon(fw);
			currentWindow := 0;
			if (w > 0) & (w <= maxWindow) & (wStatus^[w].window = fw) then
				currentWindow := w;
		end;
	end;

{$IFC ScriptEnabled }
function currentScriptWindow: integer;
	var
		fw: WindowPtr;
		w: longInt;
	begin
		fw := FrontWindow;
		if fw = nil then
			currentScriptWindow := 0
		else begin
			w := GetWRefCon(fw);
			currentScriptWindow := 0;
			if (w < 0) & (wStatus^[-w].script.stk.editWind = fw) then
				currentScriptWindow := w;
		end;
	end;
{$ENDC }

function actualWindow: windowIndex;
	var
		thePort: GrafPtr;
	begin
		if offScreenId > 0 then
			actualWindow := offScreenId
		else begin
			GetPort(thePort);
			actualWindow := GetWRefCon(WindowPtr(thePort));
		end;
	end;

function numberToString (x: integer): Str255;
	var
		s: Str255;
	begin
		NumToString(x, s);
		numberToString := s;
	end;

function windowName (windowId: windowIndex): Str255;
	begin
		windowName := concat(geoPrefix, numberToString(windowId));
	end;

function typeToString (t: objectType): Str255;
	begin
		case t of
			point2dType: 
				case currentArithmetic of
					realArithmetic: 
						typeToString := 'Real Point';
					floatArithmetic: 
						typeToString := 'Float Point';
					longIntArithmetic: 
						typeToString := 'Longint Point';
					otherwise
						typeToString := '???';
				end;
			rectangleType: 
				typeToString := 'Rectangle';
			polyLineType: 
				typeToString := 'Polyline';
			polygon2dType: 
				typeToString := 'Polygon';
			convexPolygonType: 
				typeToString := 'Convex Polygon';
			lineSegmentType: 
				typeToString := 'Line Segment';
			circleType: 
				typeToString := 'Circle';
			dDimPointType: 
				typeToString := 'D-Point';
			regularNGonType: 
				typeToString := 'Regular N-Gon';
			otherwise
				typeToString := '???';
		end;
	end;

function noSplinegon (o: obj): boolean;
	begin
		noSplinegon := not member(o, splinegon)
	end;

function computeMarkCharacter (condition: boolean): char;
	begin
		if condition then
			computeMarkCharacter := chr(diamondMark)
		else
			computeMarkCharacter := chr(noMark);
	end;

procedure enableItems (isBefore: boolean);
	var
		w: windowIndex0;
		newWindowAvailable, windowOpen, selectionExists, selectionExists1, selectionExists2, deskAccWindow: boolean;
{$IFC ScriptEnabled }
		scriptWindowOpen, scriptSelection: boolean;
{$ENDC }
		topWindowStatus: windowStatus;
		fw: WindowPtr;
		topWindowStatusSelectionLength: seqIndex0;

	procedure conditionalEnableItem (menu: MenuHandle; item: integer; condition: boolean);
		begin
			if condition then
				EnableItem(menu, item)
			else
				DisableItem(menu, item);
		end;

	function frontWindowName: Str255;
		begin
			if fw = nil then
				frontWindowName := ''
			else
				frontWindowName := Concat('''', WindowPeek(fw)^.titleHandle^^, '''');
		end;
		
{$IFC NOT THINK_PASCAL }
	PROCEDURE SetItem(theMenu: MenuRef; item: INTEGER; itemString: ConstStr255Param);
	begin
		SetMenuItemText(theMenu, item, itemString);
	end;
{$ENDC }

	procedure enableFileMenu;
		begin
			SetItem(fileMenu, saveItem, 'Save');
			SetItem(fileMenu, quitItem, 'Quit');
			if shiftKeyPressed then begin
				if optionKeyPressed then begin
					SetItem(fileMenu, closeItem, 'Close All Without Saving');
					SetItem(fileMenu, saveItem, 'Save All');
					SetItem(fileMenu, revertItem, 'Revert All Without Asking');
				end
				else if FrontWindow = infoWindow then
					SetItem(fileMenu, closeItem, 'Hide ''Info''')
				else begin
					SetItem(fileMenu, closeItem, 'Close Without Saving');
					SetItem(fileMenu, revertItem, 'Revert Without Asking');
				end;
				SetItem(fileMenu, quitItem, 'Quit Without Saving');
			end
			else if optionKeyPressed then begin
				SetItem(fileMenu, closeItem, 'Close All');
				SetItem(fileMenu, saveItem, 'Save All');
				SetItem(fileMenu, revertItem, 'Revert All');
			end
			else if FrontWindow = infoWindow then
				SetItem(fileMenu, closeItem, 'Hide ''Info''')
			else begin
				SetItem(fileMenu, closeItem, concat('Close ', frontWindowName));
				SetItem(fileMenu, saveItem, concat('Save ', frontWindowName));
				SetItem(fileMenu, revertItem, concat('Revert ', frontWindowName));
			end;
			conditionalEnableItem(fileMenu, newItem, newWindowAvailable);
			conditionalEnableItem(fileMenu, openItem, newWindowAvailable);
			conditionalEnableItem(fileMenu, closeItem, windowOpen | (fw = infoWindow));
			conditionalEnableItem(fileMenu, saveItem, windowOpen);
			conditionalEnableItem(fileMenu, saveAsItem, windowOpen);
			conditionalEnableItem(fileMenu, saveACopyAsItem, windowOpen);
			conditionalEnableItem(fileMenu, revertItem, windowOpen & wStatus^[w].modified & not wStatus^[w].systemName);
{$IFC ScriptEnabled }
			conditionalEnableItem(fileMenu, readTextItem, windowOpen | scriptWindowOpen);
			conditionalEnableItem(fileMenu, writeTextItem, selectionExists | (scriptWindowOpen & scriptSelection));
{$ELSEC }
			conditionalEnableItem(fileMenu, readTextItem, windowOpen);
			conditionalEnableItem(fileMenu, writeTextItem, selectionExists);
{$ENDC }
{$IFC Topography }
			conditionalEnableItem(topoMenu, readPolygonsItem, newWindowAvailable);
			conditionalEnableItem(topoMenu, bwMapItem, windowOpen);
			conditionalEnableItem(topoMenu, grayScaleMapItem, windowOpen & colorAvailable);
			conditionalEnableItem(topoMenu, colorMapItem, windowOpen & colorAvailable);
{$ENDC }
{$IFC NetworkEnabled }
			conditionalEnableItem(fileMenu, networkItem, windowOpen & (NrOfActCosimaConnection < 1));	(* MS: 19.7.93 *)
			conditionalEnableItem(cosimaMenu, openAsServerItem, windowOpen & (NrOfActCosimaConnection < 1));
			conditionalEnableItem(cosimaMenu, openAsClientItem, windowOpen & (NrOfActCosimaConnection < 1));
{$ENDC }
		end;

	procedure enableEditMenu;

		function rotationPossible (l: list): boolean;
			begin
				rotationPossible := member(l.ith(1), point2d) | (l.length = 2) & member(l.ith(2), point2d);
			end;

		begin
			if (undoScrap <> nil) & (w = undoWindow) then
				case undoCmd of
					dragDesktopCmd, dragSelectionCmd: 
						SetItem(editMenu, undoItem, 'Undo Drag');
					clearCmd: 
						SetItem(editMenu, undoItem, 'Undo Clear');
					clearAllCmd: 
						SetItem(editMenu, undoItem, 'Undo Clear All');
					transformCmd: 
						SetItem(editMenu, undoItem, 'Undo Transformation');
					setInfoCmd: 
						SetItem(editMenu, undoItem, 'Undo Set Info');
					randomChangeCmd: 
						SetItem(editMenu, undoItem, 'Undo Random Change');
					replaceSelectionCmd: 
						SetItem(editMenu, undoItem, 'Undo Operation');
					ungroupCmd: 
						SetItem(editMenu, undoItem, 'Undo Ungroup');
				end
			else
				SetItem(editMenu, undoItem, 'Undo');
			if optionKeyPressed then begin
				SetItem(editMenu, zoomOutItem, 'Zoom Out All');
				SetItem(editMenu, pasteItem, 'Paste Special');
			end
			else begin
				SetItem(editMenu, zoomOutItem, 'Zoom Out');
				SetItem(editMenu, pasteItem, 'Paste');
			end;
			conditionalEnableItem(editMenu, undoItem, deskAccWindow | (undoScrap <> nil) & (w = undoWindow));
{$IFC ScriptEnabled }
			conditionalEnableItem(editMenu, cutItem, selectionExists | deskAccWindow | scriptWindowOpen);
			conditionalEnableItem(editMenu, copyItem, selectionExists | deskAccWindow | scriptWindowOpen);
			conditionalEnableItem(editMenu, pasteItem, windowOpen | deskAccWindow | scriptWindowOpen);
{$ELSEC }
			conditionalEnableItem(editMenu, cutItem, selectionExists | deskAccWindow);
			conditionalEnableItem(editMenu, copyItem, selectionExists | deskAccWindow);
			conditionalEnableItem(editMenu, pasteItem, windowOpen | deskAccWindow);
{$ENDC }
			conditionalEnableItem(editMenu, cutFirstItem, selectionExists2);
			conditionalEnableItem(editMenu, copyFirstItem, selectionExists2);
			if shiftKeyPressed & not optionKeyPressed then begin
				SetItem(editMenu, selectNextItem, 'Add Next');
				conditionalEnableItem(editMenu, selectNextItem, windowOpen & (topWindowStatus.desktop.length > 0));
			end
			else if optionKeyPressed & not shiftKeyPressed then begin
				SetItem(editMenu, selectNextItem, 'Replace Next');
				conditionalEnableItem(editMenu, selectNextItem, windowOpen & (topWindowStatus.desktop.length > 0) & (topWindowStatus.selection.length > 0));
			end
			else begin
				SetItem(editMenu, selectNextItem, 'Select Next');
				conditionalEnableItem(editMenu, selectNextItem, windowOpen & (topWindowStatus.desktop.length > 0));
			end;
			conditionalEnableItem(editMenu, duplicateItem, selectionExists);
			if deskAccWindow then
				SetItem(editMenu, clearItem, 'Clear')
			else
				SetItem(editMenu, clearItem, 'Clear All');
			conditionalEnableItem(editMenu, clearItem, windowOpen | deskAccWindow);
			conditionalEnableItem(editMenu, selectAllItem, windowOpen);
			conditionalEnableItem(editMenu, redrawItem, windowOpen);
			conditionalEnableItem(editMenu, zoomInItem, windowOpen & (topWindowStatus.frames.stackPointer < maxframe));
			conditionalEnableItem(editMenu, zoomOutItem, windowOpen & (topWindowStatus.frames.stackPointer > 1));
			conditionalEnableItem(editMenu, transformItem, selectionExists);
			conditionalEnableItem(transMenu, rotateItem, selectionExists2 & rotationPossible(topWindowStatus.selection));
			conditionalEnableItem(transMenu, translateItem, selectionExists);
			conditionalEnableItem(editMenu, eyePointItem, windowOpen & (selectionExists | (topWindowStatus.desktop.length > 0)));
			conditionalEnableItem(editMenu, setUserTItem, windowOpen);
			conditionalEnableItem(editMenu, clearClipboardItem, (scrapBook <> nil) & (scrapBook.length > 0));
		end;

	procedure enableObjectsMenu;
		var
			i: objectItems;
			rndOk: boolean;
		begin
			if optionKeyPressed then
				SetItem(objectsMenu, ungroupItem, 'Ungroup All')
			else
				SetItem(objectsMenu, ungroupItem, 'Ungroup');
			conditionalEnableItem(objectsMenu, selectItem, windowOpen);
{$IFC ScriptEnabled }
			conditionalEnableItem(objectsMenu, executeItem, scriptWindowOpen & scriptSelection);
{$ENDC }
			for i := firstObjectItem to lastObjectItem do
				conditionalEnableItem(objectsMenu, i, windowOpen);
{$IFC ScriptEnabled }
			conditionalEnableItem(objectsMenu, objInfoItem, selectionExists | scriptWindowOpen);
{$ELSEC }
			conditionalEnableItem(objectsMenu, objInfoItem, selectionExists);
{$ENDC }
			conditionalEnableItem(objectsMenu, groupItem, selectionExists2);
			conditionalEnableItem(objectsMenu, ungroupItem, selectionExists & topWindowStatus.selection.sameProperty(noSplinegon));
			rndOk := windowOpen & (selectedType <> lastObjectType);
			if rndOk then
				SetItem(objectsMenu, randomItem, Concat('Random Create ', concat(typeToString(selectedType), 's'), '...'))
			else
				SetItem(objectsMenu, randomItem, 'Random Create...');
			conditionalEnableItem(objectsMenu, randomItem, rndOk);
			conditionalEnableItem(objectsMenu, randomChangeItem, selectionExists);
			conditionalEnableItem(randomGeneratorMenu, randomizeSeedItem, true);
			SetItemMark(randomGeneratorMenu, randomizeSeedItem, computeMarkCharacter(goodRandomizerAvailable));
			conditionalEnableItem(randomGeneratorMenu, resetSeedItem, true);
			conditionalEnableItem(randomGeneratorMenu, setSeedItem, true);
			for i := firstObjectItem to lastObjectItem do
				CheckItem(objectsMenu, i, selectedType = itemToType[i]);
			CheckItem(objectsMenu, selectItem, selectedType = lastObjectType);
		end;

	procedure enableArithmeticMenu;
		begin
			conditionalEnableItem(arithmeticMenu, realItem, true);
			conditionalEnableItem(arithmeticMenu, floatItem, true);
			conditionalEnableItem(arithmeticMenu, longIntItem, true);
			conditionalEnableItem(arithmeticMenu, baseItem, currentArithmetic = floatArithmetic);
			conditionalEnableItem(arithmeticMenu, precisionItem, currentArithmetic = floatArithmetic);
			conditionalEnableItem(arithmeticMenu, lpMetricItem, true);
			CheckItem(arithmeticMenu, realItem, currentArithmetic = realArithmetic);
			CheckItem(arithmeticMenu, floatItem, currentArithmetic = floatArithmetic);
			CheckItem(arithmeticMenu, longIntItem, currentArithmetic = longIntArithmetic);
		end;

	procedure enableAppleMenu;
		begin
			conditionalEnableItem(appleMenu, aboutItem, true);
			conditionalEnableItem(appleMenu, commandInfoItem, geoBenchIsComputing);
		end;

	procedure enableWindowsMenu;
		var
			i: windowIndex0;

		function unvisibleWindowExists: boolean;
			var
				i: windowIndex0;
				continue: boolean;
				w: WindowPtr;
			begin
				continue := WindowPeek(infoWindow)^.visible & ((continueButton = nil) | (WindowPeek(continueButton)^.visible));
				i := maxWindow;
				while continue & (i > 0) do begin
					w := wStatus^[i].window;
					if (w <> nil) & not WindowPeek(w)^.visible then
						continue := false;
					i := i - 1;
				end;
				unvisibleWindowExists := not continue;
			end;

		function markCharacter (w: windowIndex): char;
			begin
				with wStatus^[w] do
					markCharacter := computeMarkCharacter((window <> nil) & modified & ((desktop.length > 0) | (selection.length > 0)));
			end;

		begin
			if optionKeyPressed then
				SetItem(windowsMenu, hideItem, 'Hide All')
			else
				SetItem(windowsMenu, hideItem, concat('Hide ', frontWindowName));
			conditionalEnableItem(windowsMenu, hideItem, windowOpen | (fw = infoWindow) | (continueButton <> nil) & (fw = continueButton));
			conditionalEnableItem(windowsMenu, infoItem, (fw <> infoWindow) | (continueButton <> nil));
			conditionalEnableItem(windowsMenu, AnimationWindowItem, (continueButton <> nil) & (fw <> continueButton));
			conditionalEnableItem(windowsMenu, ShowAllItem, unvisibleWindowExists);
{$IFC ScriptEnabled }
			conditionalEnableItem(windowsMenu, geoScriptItem, windowOpen);
{$ENDC }
			for i := 1 to maxWindow do begin
				conditionalEnableItem(windowsMenu, i + lastWindowItem + 1, wStatus^[i].window <> nil);
				SetItemMark(windowsMenu, i + lastWindowItem + 1, markCharacter(i));
			end;
		end;

	procedure enableAnimationMenu;
		var
			i: integer;

		function memberAnimations (v: boolean): boolean;
			var
				i: integer;
			begin
				i := minAnimation;
				while (i <= maxAnimation) & (animationFlag[i] <> v) do
					i := i + 1;
				memberAnimations := i <= maxAnimation;
			end;

		begin
			conditionalEnableItem(animationMenu, allAnimationsOnItem, memberAnimations(false));
			conditionalEnableItem(animationMenu, allAnimationsOffItem, memberAnimations(true));
			for i := minAnimation to maxAnimation do
				CheckItem(animationMenu, i, animationFlag[i]);
		end;

{$IFC ScriptEnabled }
		var
			te: TEHandle;
{$ENDC }

	begin
		if isBefore then begin
			fw := FrontWindow;
			w := currentWindow;
			windowOpen := w > 0;
			enableAppleMenu;
			enableWindowsMenu;
			if geoBenchIsComputing then begin
				DisableItem(fileMenu, 0);
				DisableItem(editMenu, 0);
				DisableItem(objectsMenu, 0);
				DisableItem(arithmeticMenu, 0);
{$IFC AnimationEnabled }
				DisableItem(animationMenu, 0);
{$ENDC }
				DisableItem(operationsMenu, 0);
				DrawMenuBar;
			end
			else begin
				newWindowAvailable := windowCount < maxWindow;
{$IFC ScriptEnabled }
				scriptWindowOpen := currentScriptWindow < 0;
				if scriptWindowOpen then begin
					te := GetEWindowTE(wStatus^[-currentScriptWindow].script.stk.editWind);
					scriptSelection := te^^.selStart <> te^^.selEnd;
				end;
{$ENDC }
				if windowOpen then begin
					topWindowStatus := wStatus^[w];
					topWindowStatusSelectionLength := topWindowStatus.selection.length;
				end;
				selectionExists := windowOpen & (topWindowStatusSelectionLength > 0);
				selectionExists1 := windowOpen & (topWindowStatusSelectionLength = 1);
				selectionExists2 := windowOpen & (topWindowStatusSelectionLength > 1);
				deskAccWindow := (fw <> nil) & (WindowPeek(fw)^.windowKind < 0);
				enableFileMenu;
				enableEditMenu;
				enableObjectsMenu;
				enableArithmeticMenu;
				enableAnimationMenu;
			end;
		end
		else if geoBenchIsComputing then begin
			EnableItem(fileMenu, 0);
			EnableItem(editMenu, 0);
			EnableItem(objectsMenu, 0);
			EnableItem(arithmeticMenu, 0);
{$IFC AnimationEnabled }
			EnableItem(animationMenu, 0);
{$ENDC }
			EnableItem(operationsMenu, 0);
			DrawMenuBar;
		end;
	end;

procedure testObject (arguments: list; var nameList, typeList: list);
	var
		i: objectType;
		z: int;
		j: longInt;
		separatorLine: menuEntryElement;
		bigObject: boolean;

	function isHomogenVector (o: obj): boolean;
		begin
			isHomogenVector := member(o, vector) & (vector(o).length > 0) & vector(o).sameType;
		end;

	begin
		bigObject := arguments.drawingComplexity(maxStopWatchComplexity) >= maxStopWatchComplexity;
		if bigObject then
			beginCursor(stopwatchCursor);
		nameList.freeAll;
		nameList := newEmptyList;
		typeList.freeAll;
		typeList := newEmptyList;
		with arguments do begin
			currentArgumentsSameType := sameType; (* compute only once! *)
			currentArguments1IsHomogenVector := ((length = 1) | (length = 2)) & isHomogenVector(ith(1));
			currentArguments2IsHomogenVector := (length = 2) & isHomogenVector(ith(2));
		end;
		for i := firstObjectType to lastObjectType do
			if not (i in exclusionSet) & (prototypes[i] <> nil) then begin
				initCurrentMenu;
				currentArguments := arguments;
				prototypes[i].describe;
				if (nameList.length <> 0) & (currentMenu.length <> 0) then begin
					new(separatorLine);
					failNil(Handle(separatorLine));
					separatorLine.entry := '(-';
					separatorLine.item := 0;
					nameList.append(separatorLine);
					new(z);
					failNil(Handle(z));
					z.value := 0;
					typeList.append(z);
				end;
				nameList.concatenate(currentMenu);
				for j := 1 to currentMenu.length do begin
					new(z);
					failNil(Handle(z));
					z.value := ord(i);
					typeList.append(z);
				end;
				dispose(currentMenu);
			end;
		if bigObject then
			endCursor;
	end;

procedure updateScrollBars (w: windowIndex);
	var
		r: Rect;

	procedure SetParameters (scroll: ControlHandle; smin, smax, wmax: integer; var factor: real);
		var
			hiliteState: integer;
			sheetSize: longInt;
		begin
			hiliteState := 255;
			sheetSize := longInt(smax) - smin - wmax;
			if sheetSize > 0 then begin
				factor := maxScrollValue / sheetSize;
				hiliteState := 0;
{$IFC THINK_PASCAL }
				SetCtlValue(scroll, round(-smin * factor));
{$ELSEC }
				SetControlValue(scroll, roundLong(-smin * factor));
{$ENDC }
			end;
			HiliteControl(scroll, hiliteState);
		end;

	begin
		with wStatus^[w] do begin
			bigClip(window);
			r := drawingRect(window);
			UnionRect(r, sheet, sheet);
			SetParameters(verScroll, sheet.top, sheet.bottom, r.bottom, verScrollFactor);
			SetParameters(horScroll, sheet.left, sheet.right, r.right, horScrollFactor);
			sheetExtended := false;
			DrawControls(window);
			littleClip(window);
		end;
	end;

procedure ExtendSheet (x, y: integer);
	begin
		with wStatus^[actualWindow] do begin
			if x - sheetMargin < sheet.left then begin
				sheet.left := x - sheetMargin;
				sheetExtended := true;
			end;
			if x + sheetMargin > sheet.right then begin
				sheet.right := x + sheetMargin;
				sheetExtended := true;
			end;
			if y - sheetMargin < sheet.top then begin
				sheet.top := y - sheetMargin;
				sheetExtended := true;
			end;
			if y + sheetMargin > sheet.bottom then begin
				sheet.bottom := y + sheetMargin;
				sheetExtended := true;
			end;
		end;
	end;

procedure redraw (w: windowIndex);
	var
		safe: wFrame;
		drawRect: Rect;
	begin
		with wStatus^[w] do begin
			initPalette;
			drawRect := drawingRect(window);
{$IFC THINK_PASCAL }
			if rectInRgn(drawRect, thePort^.visRgn) then begin
{$ELSEC }
			if RectInRgn(drawRect, qd.thePort^.visRgn) then begin
{$ENDC }
				bigClip(window);
				EraseRect(drawRect);
				littleClip(window);
				sheet := drawingRect(window);
				sheetExtended := true;
				with frames do begin
					safe := currentFrame;
					currentFrame := stack[stackPointer];
					coordSysIsDrawn := false;
					desktop.interactiveOutput;
					selection.interactiveOutput;
					selection.interactiveHighlight;
					if window = currentGeoBenchWindow then begin
						if additionalDraw <> nil then
							additionalDraw.interactiveOutput;
						if additionalHighlight <> nil then
							additionalHighlight.interactiveHighlight;
					end;
					currentFrame := safe;
				end;
			end;
			bigClip(window);
			DrawControls(window);
			drawGrow(window);
			ValidRgn(window^.visRgn);
		end;
		with currentFrame.proD^ do begin (* inserted by Bert Leukens *)
			eyeProHasChanged := false;
			lightHasChanged := false;
			visHasChanged := false;
			proHasChanged := false;
		end;
	end;

	const
		timeBetweenMemoryAlerts = 60 * 60;
		memorySafetyMargin = 33000;

procedure infoWriteMemory (memoryAvailable: longInt);
	begin
		MoveTo(15, 60);
{$IFC THINK_PASCAL }
		writeDraw('Memory: ', startMemory - (memoryAvailable + freeListSize + freeListSizeAVL + freeTreeListSize + freeDoubleListSize + getScrapSize) : 1, ' bytes used, ', memoryAvailable : 1, ' bytes free           ');
{$ELSEC }
		DrawString(StringOf('Memory: ', startMemory - (memoryAvailable + freeListSize + freeListSizeAVL + freeTreeListSize + freeDoubleListSize + getScrapSize) : 1, ' bytes used, ', memoryAvailable : 1, ' bytes free           '));
{$ENDC }
		MoveTo(15, 75);
	end;

procedure writeTiming;
	var
		save: GrafPtr;
		w: windowIndex0;
		memoryAvailable: longInt;
	begin
		memoryAvailable := FreeMem;
		if memoryAlertEnabled & (memoryAvailable < memorySafetyMargin) then begin
			if TickCount - lastMemoryAlertPrinted > timeBetweenMemoryAlerts then begin
				lastMemoryAlertPrinted := TickCount;
				beginCursor(arrowCursor);
				memoryAlertEnabled := CautionAlert(memoryFullAlertResource, nil) <> suppressItem;
				endCursor;
			end;
		end
		else
			lastMemoryAlertPrinted := 0;
		GetPort(save);
		SetPort(infoWindow);
		MoveTo(15, 30);
		if (cpuTimeUsedLower = realTimeUsed) & (cpuTimeUsedUpper = realTimeUsed) then
{$IFC THINK_PASCAL }
			writeDraw('Time used: ', realTimeUsed : 7 : 3, ' secs.', ' ' : 250)
		else
			writeDraw(cpuTimeUsedLower : 7 : 3, '  CPU  ', cpuTimeUsedUpper : 7 : 3, ' secs. / Real: ', realTimeUsed : 7 : 3, ' secs.          ');
{$ELSEC }
			DrawString(StringOf('Time used: ', realTimeUsed : 7 : 3, ' secs.', ' ' : 250))
		else
			DrawString(StringOf(cpuTimeUsedLower : 7 : 3, '  CPU  ', cpuTimeUsedUpper : 7 : 3, ' secs. / Real: ', realTimeUsed : 7 : 3, ' secs.          '));
{$ENDC }
		infoWriteMemory(memoryAvailable);
		w := currentWindow;
		if w > 0 then
			with wStatus^[w] do
				if (selection <> nil) & (selection.length > 0) then begin
{$IFC THINK_PASCAL }
					writeDraw('Type: ', selection.ith(1).getTextType);
					if selection.length > 1 then begin
						writeDraw('+', (selection.length - 1) : 1, ' Object');
						if selection.length > 2 then
							writeDraw('s');
					end;
				end;
		writeDraw(' ' : 250);
{$ELSEC }
					DrawString(StringOf('Type: ', selection.ith(1).getTextType));
					if selection.length > 1 then begin
						DrawString(StringOf('+', (selection.length - 1) : 1, ' Object'));
						if selection.length > 2 then
							DrawString(StringOf('s'));
					end;
				end;
		DrawString(StringOf(' ' : 250));
{$ENDC }
		displayInfoString(infoString);
		SetPort(save);
	end;

procedure initTiming (var realStartTime: longInt);
	begin
		startTimeCorrections := 0;
		startTime := TickCount;
		realStartTime := startTime;
	end;

procedure finishTiming (realStartTime: longInt);
	var
		endTickCount: longInt;
	begin
		endTickCount := TickCount;
		cpuTimeUsedLower := (endTickCount - startTime - startTimeCorrections) / 60;
		cpuTimeUsedUpper := (endTickCount - startTime) / 60;
		realTimeUsed := (endTickCount - realStartTime) / 60;
	end;

procedure sequence.dynamicExecution (function computeResult (objects: sequence): obj; highlightResult, showType: boolean);
	var
		m: Point;
		r: rectangle;
		aborted, userClicked: boolean;
		result, dragObj: obj;
		currentType, previousType: Str255;
		oldAnimationFlag: animationVector;
		oldPort, thisPort, where: GrafPtr;
		oldFrame, thisFrame: wFrame;

	procedure showResult;
		begin
			if result <> nil then begin
				result.interactiveOutput;
				if highlightResult then
					result.interactiveHighlight;
				result.freeAll;
			end;
		end;

{$IFC NOT THINK_PASCAL }
{$PUSH }
{$PRAGMAC warn_unusedarg off }
{$ENDC }
	procedure doComputeResult (o: obj);
		var
			aEnable: boolean;
			save: GrafPtr;
		begin
			showResult;
			aEnable := abortEnable;
			abortEnable := false;
			result := computeResult(self);
			abortEnable := aEnable;
			if result = nil then
				currentType := 'No object available'
			else begin
				currentType := result.getTextType;
				result.interactiveOutput;
				if highlightResult then
					result.interactiveHighlight;
			end;
			if showType & (currentType <> previousType) then begin
				displayInfoString(concat('Type of result: ', currentType));
				previousType := currentType;
			end;
			GetPort(save);
			SetPort(infoWindow);
			infoWriteMemory(FreeMem);
			SetPort(save);
		end;
{$IFC NOT THINK_PASCAL }
{$POP }
{$ENDC }

	function objSelected (x: obj): boolean;
		begin
			objSelected := x.isSelected(r);
		end;

	begin (* sequence.dynamicExecution *)
		beginCursor(littleCrossCursor);
		oldAnimationFlag := animationFlag;
		setAllAnimationFlag(false);
		GetPort(oldPort);
		oldFrame := currentFrame;
		interactiveHighlight;
		additionalHighlight := self;
		new(r);
		failNil(Handle(r));
		dragObj := nil;
		displayInfoStringCommand('Click at an object and drag it!');
		repeat
			repeat
				aborted := AbortInQueueUserClick(userClicked, where, m) | abortFlag;
			until userClicked | aborted;
			if not aborted & (where = oldPort) then begin
				getSelectionRectangle(m, r);
				dragObj := existsObject(objSelected);
			end;
		until (dragObj <> nil) | aborted;
		r.free;

		if dragObj <> nil then begin
			result := nil;
			previousType := '';
			doComputeResult(nil);
			dragObj.dragObject(doNothingObjP, doComputeResult, m);
			showResult;
			displayInfoString('');
		end;
		additionalHighlight := nil;
		GetPort(thisPort);
		thisFrame := currentFrame;
		SetPort(oldPort);
		currentFrame := oldFrame;
		interactiveHighlight;
		SetPort(thisPort);
		currentFrame := thisFrame;
		animationFlag := oldAnimationFlag;
		redrawScreen := true;
		doBeep := false;
		abortFlag := abortFlag | aborted;
		FlushEvents(mUpMask + mDownMask, 0);
		displayInfoString('');
		endCursor;
	end;

procedure DoMClobber (m: MenuHandle);
	begin
		DisposeMenu(m);
	end;

{$IFC THINK_PASCAL }
function goodVersion: boolean;
	begin
		goodVersion := (currentVersion = version1) | (currentVersion = version2) | (currentVersion = version3) | (currentVersion = version4) | (currentVersion = version5) | (currentVersion = version6) | (currentVersion = version7) | (currentVersion = version8) | (currentVersion = version9) | (currentVersion = version10) | (currentVersion = version11);
	end;
{$ELSEC }
function goodVersion: boolean;
	begin
		goodVersion := currentVersion = version12;
	end;
{$ENDC }

procedure stopwatchFreeAll (var o: obj);
	var
		bigObject: boolean;
	begin
		if o <> nil then begin
			bigObject := o.drawingComplexity(maxStopWatchComplexity) >= maxStopWatchComplexity;
			if bigObject then
				beginCursor(stopwatchCursor);
			o.freeAll;
			o := nil;
			if bigObject then
				endCursor;
		end;
	end;

function stopwatchDuplicateAll (o: obj): obj;
	var
		bigObject: boolean;
	begin
		if o = nil then
			stopwatchDuplicateAll := nil
		else begin
			bigObject := o.drawingComplexity(maxStopWatchComplexity) >= maxStopWatchComplexity;
			if bigObject then
				beginCursor(stopwatchCursor);
			stopwatchDuplicateAll := o.duplicateAll;
			if bigObject then
				endCursor;
		end;
	end;

procedure forgetUndo;	(*	See comment in interface part. *)
	begin
		stopwatchFreeAll(obj(undoScrap));
	end;

function getScrapSize: longInt;
	var
{$IFC THINK_PASCAL }
		s: PScrapStuff;
{$ELSEC }
		s: ScrapStuffPtr;
{$ENDC }
	begin
		s := InfoScrap;
		if s = nil then
			getScrapSize := 0
		else
			getScrapSize := s^.scrapSize;
	end;

procedure idleTask;
	var
		current: GrafPtr;
		pt: Point;
		r: Rect;

	begin
		GetPort(current);
		if FrontWindow = current then begin
			if wStatus^[currentWindow].sheetExtended then
				updateScrollBars(currentWindow);
			garbageTimer := garbageTimer + 1;
			if garbageTimer = garbageTime then begin
				writeTiming;
				garbageTimer := 0;
			end;
			r := drawingRect(FrontWindow);
			GetMouse(pt);
			if PtInRect(pt, r) then begin
				if selectedItem = selectItem then
					cursorSet(arrowCursor)
				else
					cursorSet(littleCrossCursor);
				writeCursorCoordinates(false);
			end
			else
				cursorSet(arrowCursor);
		end;
	end;

procedure DoCursorUpdate;
	begin
		EraseRect(infoWindow^.portRect);
		writeCursorCoordinates(true);
		writeTiming;
		redrawMemoryMeter;
	end;

procedure updatePalette (item: integer);
	var
		w: WindowPtr;
	begin
		w := wStatus^[actualWindow].window;
		bigClip(w);
		if selectedItem = selectItem then
			InvertRect(paletteSelect)
		else
			InvertRect(paletteObjects[selectedItem]);
		if item = selectItem then
			InvertRect(paletteSelect)
		else
			InvertRect(paletteObjects[item]);
		selectedItem := item;
		littleClip(w);
	end;

procedure deactivatePalette;
	var
		w: WindowPtr;
	begin
		w := wStatus^[actualWindow].window;
		bigClip(w);
		if selectedItem = selectItem then
			InvertRect(paletteSelect)
		else
			InvertRect(paletteObjects[selectedItem]);
		littleClip(w);
	end;

function baseOk (x: extended): boolean;
	begin
		baseOk := (2 <= x) & (x <= 99) & (trunc(x) = x);
	end;

function precisionOk (x: extended): boolean;
	begin
		precisionOk := (1 <= x) & (x <= 50) & (trunc(x) = x);
	end;

function lpMetricOk (x: extended): boolean;
	begin
		lpMetricOk := (1 <= x) & (x < 10) | (x = lpInfinity);
	end;

{$IFC NOT THINK_PASCAL }
{$PUSH }
{$PRAGMAC warn_unusedarg off }
{$ENDC }
procedure DoArithmeticMenu (menu, item: integer; when: longInt);
	var
		t: extended;
	begin
		case item of
			realItem: 
				currentArithmetic := realArithmetic;
			longIntItem: 
				currentArithmetic := longIntArithmetic;
			floatItem: 
				currentArithmetic := floatArithmetic;
			baseItem:  begin
				t := currentBase;
				if getUserParameter1('Base', currentBase, t, @baseOk) then
{$IFC THINK_PASCAL }
					currentBase := trunc(t);
{$ELSEC }
					currentBase := truncLong(t);
{$ENDC }
			end;
			lpMetricItem:  begin
				t := lpMetric;
				if getUserParameter1('Lp Metric', lpMetric, t, @lpMetricOk) then
					lpMetric := t;
			end;
			precisionItem:  begin
				t := currentPrecision;
				if getUserParameter1('Precision', currentPrecision, t, @precisionOk) then
{$IFC THINK_PASCAL }
					currentPrecision := trunc(t);
{$ELSEC }
					currentPrecision := truncLong(t);
{$ENDC }
			end;
		end;
	end;
{$IFC NOT THINK_PASCAL }
{$POP }
{$ENDC }

end.
