(*	XYZ GeoBench (eXperimental geometrY Zurich):		*)
(*	An object oriented, interactive workbench for		*)
(*	experimental geometric computation.					*)
(*														*)
(*	 1999 by Peter Schorn, peter.schorn@acm.org		*)
(*	Culmannstrasse 77, CH-8006 Zrich, Switzerland		*)
(*	This software may be copied freely for educational	*)
(*	and research purposes only. For commercial use,		*)
(*	please contact the author.							*)
(*														*)
(*	Version 5.0.5: 30-Sep-1999							*)

unit gravityCenter;

interface

{$IFC Tutorial }
uses
	pointVector;
{$ENDC }

implementation
{$IFC Tutorial }

{$SETC version3 = TRUE }

{$IFC UNDEFINED version1 }
{$SETC version1 = FALSE }
{$ENDC }
{$IFC UNDEFINED version2 }
{$SETC version2 = FALSE }
{$ENDC }
{$IFC UNDEFINED version3 }
{$SETC version3 = FALSE }
{$ENDC }

{$IFC version1 }
function pointVector.gravityCenter: point2d;
	var
		result: point2d;
		i: seqIndex;
	begin
		if length = 0 then
			gravityCenter := nil
		else begin
			result := point2d(elements^^[1].duplicate);
			result.setXY(0, 0);
			for i := 1 to length do
				with point2d(elements^^[i]) do
					result.setXY(result.getX + getX, result.getY + getY);
			result.setXY(result.getX / length, result.getY / length);
			gravityCenter := result;
		end;
	end;
{$ENDC }

{$IFC version2 }
function pointVector.gravityCenter: point2d;
	var
		result: point2d;
		i: seqIndex;
	begin
		if length = 0 then
			gravityCenter := nil
		else begin
			result := point2d(elements^^[1].duplicate);
			result.setXY(0, 0);
			for i := 1 to length do
				with point2d(elements^^[i]) do begin
{$IFC AnimationEnabled }
					if animationFlag[ACenterOfGravityItem] then begin
						interactiveFlash;
						waitForClick(animationFlag[ACenterOfGravityItem]);
					end;
{$ENDC }
					result.setXY(result.getX + getX, result.getY + getY);
				end;
			result.setXY(result.getX / length, result.getY / length);
			gravityCenter := result;
		end;
	end;
{$ENDC }

{$IFC version3 }
function pointVector.gravityCenter: point2d;
	var
		result: point2d;
		i: seqIndex;
	begin
		if length = 0 then
			gravityCenter := nil
		else begin
			result := point2d(elements^^[1].duplicate);
			result.setXY(0, 0);
			for i := 1 to length do
				with point2d(elements^^[i]) do begin
{$IFC AnimationEnabled }
					if userAbort then begin
						result.free;
						gravityCenter := nil;
						exit(gravityCenter);
					end;
					if animationFlag[ACenterOfGravityItem] then begin
						interactiveFlash;
						waitForClick(animationFlag[ACenterOfGravityItem]);
					end;
{$ENDC }
					result.setXY(result.getX + getX, result.getY + getY);
				end;
			result.setXY(result.getX / length, result.getY / length);
			gravityCenter := result;
		end;
	end;
{$ENDC }


{$ENDC }
end.
